package de.thpeetz.kontor.admin.views;

import java.util.List;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.combobox.ComboBox;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;

import de.thpeetz.kontor.admin.data.Assignment;
import de.thpeetz.kontor.admin.data.Permission;
import de.thpeetz.kontor.admin.data.Profile;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class AssignmentForm extends FormLayout {

    ComboBox<Profile> profile = new ComboBox<>("Proile");
    ComboBox<Permission> permission = new ComboBox<>("Permission");

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<Assignment> binder = new BeanValidationBinder<>(Assignment.class);

    public AssignmentForm(List<Profile> profiles, List<Permission> permissions) {
        addClassName("assignment-form");
        binder.bindInstanceFields(this);

        profile.setItems(profiles);
        profile.setItemLabelGenerator(Profile::getUserName);
        permission.setItems(permissions);
        permission.setItemLabelGenerator(Permission::getName);
        add(profile, permission, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(e -> save.setEnabled(binder.isValid()));
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setAssignment(Assignment assignment) {
        binder.setBean(assignment);
    }

    public abstract static class AssignmentFormEvent extends ComponentEvent<AssignmentForm> {
        private Assignment assignment;

        protected AssignmentFormEvent(AssignmentForm source, Assignment assignment) {
            super(source, false);
            this.assignment = assignment;
        }

        public Assignment getAssignment() {
            return assignment;
        }
    }

    public static class SaveEvent extends AssignmentFormEvent {
        SaveEvent(AssignmentForm source, Assignment assignment) {
            super(source, assignment);
        }
    }

    public static class DeleteEvent extends AssignmentFormEvent {
        DeleteEvent(AssignmentForm source, Assignment assignment) {
            super(source, assignment);
        }
    }

    public static class CloseEvent extends AssignmentFormEvent {
        CloseEvent(AssignmentForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
